Subject: Re: linux-next: manual merge of the logfs tree with Linus' tree

From: Jörn Engel <[email-masked]>
Date: Wed, 2 Nov 2011 20:00:46 +0100

On Tue, 1 November 2011 14:10:00 +1100, Stephen Rothwell wrote:
> 
> Hi all,
> 
> Today's linux-next merge of the logfs tree got a conflict in
> fs/logfs/file.c between commit 02c24a82187d ("fs: push i_mutex and
> filemap_write_and_wait down into ->fsync() handlers") from Linus' tree
> and commit 39da12ef4bbe ("logfs: take write mutex lock during fsync and
> sync") from the logfs tree.
> 
> I have no idea what needs to be done here.  I fixed it like below to make
> it build, but a better fix is needed.

From a code perspective your fix below is correct, to the best of my
judgement.  I'm less sure what to do from a git perspective.
Explicitly tell Linus about it in the logfs pull request?

> diff --cc fs/logfs/file.c
> index b548c87,f85d603..0000000
> --- a/fs/logfs/file.c
> +++ b/fs/logfs/file.c
> @@@ -219,20 -219,13 +219,22 @@@ long logfs_ioctl(struct file *file, uns
>   	}
>   }
>   
>  -int logfs_fsync(struct file *file, int datasync)
>  +int logfs_fsync(struct file *file, loff_t start, loff_t end, int datasync)
>   {
>   	struct super_block *sb = file->f_mapping->host->i_sb;
>  +	struct inode *inode = file->f_mapping->host;
>  +	int ret;
>  +
>  +	ret = filemap_write_and_wait_range(inode->i_mapping, start, end);
>  +	if (ret)
>  +		return ret;
>   
>  +	mutex_lock(&inode->i_mutex);
> + 	logfs_get_wblocks(sb, NULL, WF_LOCK);
>   	logfs_write_anchor(sb);
> + 	logfs_put_wblocks(sb, NULL, WF_LOCK);
>  +	mutex_unlock(&inode->i_mutex);
>  +
>   	return 0;
>   }
>   

Jörn

-- 
You can take my soul, but not my lack of enthusiasm.
-- Wally